config/routes.rb
Rails.application.routes.draw do
  namespace :api do
    namespace :v1 do
      get 'tile/index'
    end
  end
  namespace :api do
    namespace :v1 do
      get 'building_plan/index'
    end
  end
  namespace :api do
    namespace :v1 do
      get 'action_plan/index'
    end
  end
  # Static pages
  root 'static_pages#home'
  get '/play', to: 'static_pages#play'
  get '/about', to: 'static_pages#about'
  get '/manual', to: 'static_pages#manual'

  # Devise related routes (for users and authentication)
  devise_for :users, skip: :all
  devise_scope :user do
    post 'login', to: 'users/sessions#create'
    delete 'logout', to: 'users/sessions#destroy'
    post 'register', to: 'users/registrations#create'
  end

  # Rest API routes
  namespace :api, defaults: { format: :json } do
    namespace :v1 do
      resources :locale, only: :index
      resources :game_session, only: %i[create index destroy]
      resources :building, only: %i[create show destroy]
      resources :status, only: %i[index show]
      resources :player_action, only: %i[create]
      resources :action_plan, only: %i[index]
      resources :building_plan, only: %i[index]
      resources :tile, only: %i[index]
    end
  end

end

app/views/layouts/_error_messages.html.erb
<% if object.errors.any? %>
  <div id="error_explanation">
    <div class="alert alert-danger">
      The form contains <%= pluralize(object.errors.count, "error") %>.
    </div>
    <ul>
    <% object.errors.full_messages.each do |msg| %>
      <li><%= msg %></li>
    <% end %>
    </ul>
  </div>
<% end %>

app/views/layouts/_header.html.erb
<%= render 'layouts/login_form' %>
<%= render 'layouts/register_form' %>

<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <a class="navbar-brand" href="#">Shipwreck</a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarColor03" aria-controls="navbarColor03" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  <div class="collapse navbar-collapse">
    <ul class="navbar-nav mr-auto">
      <li class="nav-item active">
        <%= link_to t('layout.home'), root_path, class: "nav-link" %>
      </li>
      <li class="nav-item">
        <%= link_to t('layout.about'), about_path, class: "nav-link" %>
      </li>
      <li class="nav-item">
        <%= link_to t('layout.manual'), manual_path, class: "nav-link" %>
      </li>
      <li class="nav-item">
        <%= link_to t('layout.play'), play_path, class: "nav-link user-link " + (user_signed_in? ? "" : 'disabled') %>
      </li>
    </ul>
    <%= form_with(model: resource, as: resource_name,
                 url: logout_path,
                 method: :delete,
                 html: {:id => "user_logout", data: { type: 'json' }, class: "form-inline my-2 my-lg-0 user-logged-in" + (user_signed_in? ? '' : ' hidden') }
        ) do |f| %>
      <%= f.submit t('layout.logout'), class: "btn btn-primary" %>
    <% end %>
    <ul id="user_login"  class="navbar-nav ml-auto user-logged-out <%= 'hidden' if user_signed_in? %>">
      <li class="nav-item">
        <span class="nav-link" data-toggle="modal" data-target="#login_form"><%= t('layout.login') %></span>
      </li>
      <li class="nav-item">
        <span class="nav-link" data-toggle="modal" data-target="#register_form"><%= t('layout.register') %></span>
      </li>
    </ul>
  </div>
</nav>

app/views/layouts/_login_form.html.erb
<div id="login_form" class="modal fade" role="dialog">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title"><%= t('layout.login') %></h4>
        <button type="button" class="close" data-dismiss="modal">&times;</button>
      </div>
      <div class="modal-body">
        <%= form_with(model: resource, as: resource_name,
                               url: login_path,
                               html: {:id => "sign_in_user", data: { type: 'json' } }
            ) do |f| %>
          <div class="container hidden"></div>
          <div class="form-group">
            <%= f.label :email, t('layout.email') %>
            <%= f.email_field :email, required: true, class: 'form-control', placeholder: t('layout.email'), autocomplete: "email" %>

            <%= f.label :password, t('layout.password') %>
            <%= f.password_field :password, required: true, class: 'form-control', placeholder: t('layout.password') %>

            <div class="form-group form-check">
              <%= f.check_box :remember_me %>
              <%= f.label :remember_me, t('layout.remember_me') %>
            </div>
          </div>
          <%= f.submit t('layout.login'), class: "btn btn-success" %>
        <% end %>
      </div>
    </div>
  </div>
</div>

app/views/layouts/_register_form.html.erb
<div id="register_form" class="modal fade" role="dialog">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title"><%= t('layout.register') %></h4>
        <button type="button" class="close" data-dismiss="modal">&times;</button>
      </div>
      <div class="modal-body">
        <%= form_with(model: resource, as: resource_name,
                     url: register_path,
                     :html => {:id => "sign_up_user"}
            ) do |f| %>
          <div class="form-group">
            <%= f.label :email, t('layout.email') %>
            <%= f.email_field :email, required: true, autofocus: true, class: 'form-control', placeholder: t('layout.email') %>
          </div>

          <div class="form-group">
            <%= f.label :password, t('layout.password') %>
            <%= f.password_field :password, required: true, class: 'form-control', placeholder: t('layout.password') %>

            <%= f.label :password_confirmation, t('layout.password_confirmation') %>
            <%= f.password_field :password_confirmation, required: true, class: 'form-control', placeholder: t('layout.password_confirmation') %>
          </div>
          <%= f.submit t('layout.register'), class: "btn btn-success" %>
        <% end %>
      </div>
    </div>
  </div>
</div>

app/views/layouts/_shim.html.erb
<!--[if lt IE 9]>
<script src="//cdnjs.cloudflare.com/ajax/libs/html5shiv/r29/html5.min.js">
</script>
<![endif]-->

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8"/>
    <title>Shipwreck</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
    <% if yield(:js_app) %>
      <%= javascript_include_tag yield(:js_app), 'data-turbolinks-track': 'reload' %>
    <% end %>

    <%= render 'layouts/shim' %>
  </head>

  <body>
    <%= render 'layouts/header' %>
    <div id="page-content" class="container">
      <%= yield %>
    </div>
  </body>
</html>